/*
 * Ʈ: TLE2Framework
 * ϸ: ViewSetConfig.java
 * ۼ: 2004. 10. 29
 */
package tle.framework.component.impl.uicreator.config;

import java.net.URL;
import java.util.List;
import java.util.Map;

import org.apache.commons.digester.Digester;
import org.apache.commons.digester.xmlrules.DigesterLoader;

import tle.framework.log.Logger;
import tle.framework.util.TLEConfigPathUtil;

/**
 * &lt;view-set> ±  Ѵ.
 * 
 * @author ֹ
 * @since 2.0
 */
public class ViewSetConfig {
	private String viewSetID;
    private String authFormViewID;
    private String noAuthViewID;
    private String errorViewID;
    
	private Map viewConfigMap = new java.util.HashMap();
	
	public String getViewSetID() {
		return viewSetID;
	}
	public void setViewSetID(String viewSetID) {
		this.viewSetID = viewSetID;
	}
	public String getAuthFormViewID() {
		return authFormViewID;
	}
	public void setAuthFormViewID(String authFormViewID) {
		this.authFormViewID = authFormViewID;
	}
	public ViewConfig getAuthFormViewConfig() {
		return (ViewConfig)viewConfigMap.get(authFormViewID);
	}
	public String getErrorViewID() {
		return errorViewID;
	}
	public void setErrorViewID(String errorViewID) {
		this.errorViewID = errorViewID;
	}
	public ViewConfig getErrorViewConfig() {
		return (ViewConfig)viewConfigMap.get(errorViewID);
	}
	public String getNoAuthViewID() {
		return noAuthViewID;
	}
	public void setNoAuthViewID(String noAuthViewID) {
		this.noAuthViewID = noAuthViewID;
	}
	public ViewConfig getNoAuthViewConfig() {
		return (ViewConfig)viewConfigMap.get(noAuthViewID);
	}
	public void addViewConfig(ViewConfig viewConfig) {
		if (viewConfigMap == null) viewConfigMap = new java.util.HashMap();
		viewConfigMap.put(viewConfig.getViewID(), viewConfig);
		viewConfig.setViewSetConfig(this);
	}
	public ViewConfig getViewConfig(String viewID) {
		return (ViewConfig)viewConfigMap.get(viewID);
	}
	public void loadViewList(String file) {
		try {
			URL ruleXml = UIConfigurationDigester.class.getClassLoader().getResource("tle/framework/component/impl/uicreator/config/UIConfiguration.viewlist.rule.xml");
			Digester digester = DigesterLoader.createDigester(ruleXml);
			List list = (List)digester.parse(TLEConfigPathUtil.replace(file));
			for (int i = 0 ; i < list.size() ; i++) {
				ViewConfig viewConfig = (ViewConfig)list.get(i);
				addViewConfig(viewConfig);
			}
		} catch(Throwable e) {
			Logger.error("ViewSetConfig.loadViewList():"+e.getMessage(), e);
		}
	}
}
